
#include <iostream>

#include "Vector.h"

using namespace std;
using namespace nemo;

int main(){
	
	MathVector<int> i(dim(2), 42);

	// RealVector is a typedef on MathVector<double>
	RealVector x(dim(3), 21.0);
	cout << x[0] << endl;
	x[1] = 3.14; 
	cout << x[1] << endl;

	RealVector y(x); // no deep-copy here
	y[0] = 2.7; // this is where the copy is made (copy on write!)
	cout << x[0] << endl;
	cout << y[0] << endl;
	
	// use standard arithmetic operators
	RealVector z = 2 * (x - y);
	cout << x << endl;
	cout << y << endl;
	cout << z << endl;
}

